#!/usr/bin/python3
import discord
import requests
import os, random, sys
from fuzzywuzzy import fuzz, process
from minio import Minio
from minio.error import S3Error

from on_message_delete import message_delete
from on_message import parse_message

#globals for discord
if 'DISCORD_TOKEN' not in os.environ:
    raise Exception("DISCORD_TOKEN was not set!")
token = os.environ['DISCORD_TOKEN']
client = discord.Client()

###############################################################################
# Discord client code


# primary message handler
@client.event
async def on_message(message):
    if message.author == client.user:
        return
    if len(message.content) == 0: # if its empty, like an uploaded image, ignore it
        return
    return await parse_message(client, message)

# messege delete handler
@client.event
async def on_message_delete(message):
    if message.author == client.user:
        return
    return await message_delete(client, message)

@client.event
async def on_ready():
    print(f'{client.user} has connected to Discord!')

def main() -> int:
    print('Connecting client to discord...')
    client.run(token)
    dclient = client

if __name__ == '__main__':
    sys.exit(main())
