#!/usr/bin/python3
import requests
import os, random, sys
from memes import parseMeme, memeCount, memeDump, allMemes, uploadMeme, memeBlame
import discord

async def showHelp(very, useless, arguments):
    str  = "```Usage:\n"
    str += "!help\n"
    str += " Print this message\n"
    str += "!meme [QUERY]\n"
    str += " Get a meme. Query for the exact name or search. Paramater is optional\n"
    str += "!memecount\n"
    str += " Print total number of memes in the store\n"
    str += "!memedump [COUNT]\n"
    str += " Get COUNT random memes. If COUNT is not provided, we default to 5\n"
    str += "!allmemes QUERY\n"
    str += " Get all memes that are like the given query\n"
    str += "!up [NAME]\n"
    str += " Upload a meme. If NAME is provided it will be named as such.\n"
    str += " You need to either attach the meme with the message, or reply to a\n"
    str += " message with the meme you want to upload\n"
    str += "!blame [NAME/QUERY]\n"
    str += " Returns who uploaded the meme that matches the name or query\n"
    str += " You can also reply to a message with a meme attached\n"
    str += " to find the uploader\n"
    str += "```"
    return str

# dictionary associating
# a command to a function name
calldict = {
    # S3 memes
    "!meme"      : parseMeme,
    "!memecount" : memeCount,
    "!memedump"  : memeDump,
    "!allmemes"  : allMemes,
    "!up"        : uploadMeme,
    "!upload"    : uploadMeme,
    "!uploadmeme": uploadMeme,
    "!memeblame" : memeBlame,
    "!blame"     : memeBlame,
    # plex
    #"!plexleaderboard" : getTopUsers,
    "!help"      : showHelp,
}


# parse the message
async def parse_message(client, message):
    command = message.content.split()
    cmd_input = command[0].lower()

    # if i know this command
    if cmd_input in calldict.keys():
        print(f'{client.user} was passed a command I know! ({message.content})')
        result = await calldict[cmd_input](command, message, client)
        if isinstance(result, discord.File):
            print(f'{client.user} is replying with a file ({result.filename})')
            return await message.channel.send(file=result, reference=message)
        else:
            print(f'{client.user} is replying with the string ({result})')
            return await message.channel.send(result, reference=message)

    pass
